Attribute VB_Name = "modMediaEngine"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2020

Option Explicit

' ----==== Public Enums ====----
Public Enum VARENUM
    VT_EMPTY = 0  '&H0
    VT_NULL = 1  '&H1
    VT_I2 = 2  '&H2
    VT_I4 = 3  '&H3
    VT_R4 = 4  '&H4
    VT_R8 = 5  '&H5
    VT_CY = 6  '&H6
    VT_DATE = 7  '&H7
    VT_BSTR = 8  '&H8
    VT_DISPATCH = 9  '&H9
    VT_ERROR = 10  '&HA
    VT_BOOL = 11  '&HB
    VT_VARIANT = 12  '&HC
    VT_UNKNOWN = 13  '&HD
    VT_DECIMAL = 14  '&HE
    VT_I1 = 16  '&H10
    VT_UI1 = 17  '&H11
    VT_UI2 = 18  '&H12
    VT_UI4 = 19  '&H13
    VT_I8 = 20  '&H14
    VT_UI8 = 21  '&H15
    VT_INT = 22  '&H16
    VT_UINT = 23  '&H17
    VT_VOID = 24  '&H18
    VT_HRESULT = 25  '&H19
    VT_PTR = 26  '&H1A
    VT_SAFEARRAY = 27  '&H1B
    VT_CARRAY = 28  '&H1C
    VT_USERDEFINED = 29  '&H1D
    VT_LPSTR = 30  '&H1E
    VT_LPWSTR = 31  '&H1F
    VT_RECORD = 36  '&H24
    VT_FILETIME = 64  '&H40
    VT_BLOB = 65  '&H41
    VT_STREAM = 66  '&H42
    VT_STORAGE = 67  '&H43
    VT_STREAMED_OBJECT = 68  '&H44
    VT_STORED_OBJECT = 69  '&H45
    VT_BLOB_OBJECT = 70  '&H46
    VT_CF = 71  '&H47
    VT_CLSID = 72  '&H48
    VT_VECTOR = 4096  '&H1000
    VT_ARRAY = 8192  '&H2000
    VT_BYREF = 16384  '&H4000
    VT_RESERVED = 32768  '&H8000
    VT_ILLEGAL = 65535 '&HFFFF
    VT_ILLEGALMASKED = 4095 '&HFFF
    VT_TYPEMASK = 4095 '&HFFF
End Enum

Public Enum Role
    eConsole = 0&
    eMultimedia = 1&
    eCommunications = 2&
End Enum

Public Enum EngineMode
    AudioMode = 0&
    RenderingMode = 1&
    FrameServerMode = 2&
End Enum

Public Enum AUDIO_STREAM_CATEGORY
    AudioCategory_Other = 0&
    AudioCategory_ForegroundOnlyMedia = 1&
    AudioCategory_BackgroundCapableMedia = 2&
    AudioCategory_Communications = 3&
    AudioCategory_Alerts = 4&
    AudioCategory_SoundEffects = 5&
    AudioCategory_GameEffects = 6&
    AudioCategory_GameMedia = 7&
    AudioCategory_GameChat = 8&
    AudioCategory_Speech = 9&
    AudioCategory_Movie = 10&
    AudioCategory_Media = 11&
End Enum

Public Enum MF3DVideoOutputType
    MF3DVideoOutputType_BaseView = 0&
    MF3DVideoOutputType_Stereo = 1&
End Enum

Public Enum MF_MEDIA_ENGINE_S3D_PACKING_MODE
    MF_MEDIA_ENGINE_S3D_PACKING_MODE_NONE = 0&
    MF_MEDIA_ENGINE_S3D_PACKING_MODE_SIDE_BY_SIDE = 1&
    MF_MEDIA_ENGINE_S3D_PACKING_MODE_TOP_BOTTOM = 2&
End Enum

Public Enum MF_MEDIA_FORMAT_CHANGE
    MF_MEDIA_VIDEO = 0&
    MF_MEDIA_AUDIO = 1&
End Enum

Public Enum MF_MEDIA_ENGINE_SEEK_MODE
    MF_MEDIA_ENGINE_SEEK_MODE_NORMAL = 0&
    MF_MEDIA_ENGINE_SEEK_MODE_APPROXIMATE = 1&
End Enum

Public Enum MF_MEDIA_ENGINE_CANPLAY
    MF_MEDIA_ENGINE_CANPLAY_NOT_SUPPORTED = 0&
    MF_MEDIA_ENGINE_CANPLAY_MAYBE = 1&
    MF_MEDIA_ENGINE_CANPLAY_PROBABLY = 2&
End Enum

Public Enum MFMEDIASOURCE_CHARACTERISTICS
    MFMEDIASOURCE_IS_LIVE = &H1&
    MFMEDIASOURCE_CAN_SEEK = &H2&
    MFMEDIASOURCE_CAN_PAUSE = &H4&
    MFMEDIASOURCE_HAS_SLOW_SEEK = &H8&
    MFMEDIASOURCE_HAS_MULTIPLE_PRESENTATIONS = &H10&
    MFMEDIASOURCE_CAN_SKIPFORWARD = &H20&
    MFMEDIASOURCE_CAN_SKIPBACKWARD = &H40&
    MFMEDIASOURCE_DOES_NOT_USE_NETWORK = &H80&
End Enum

Public Enum MF_MEDIA_ENGINE_PRELOAD
    MF_MEDIA_ENGINE_PRELOAD_MISSING = 0&
    MF_MEDIA_ENGINE_PRELOAD_EMPTY = 1&
    MF_MEDIA_ENGINE_PRELOAD_NONE = 2&
    MF_MEDIA_ENGINE_PRELOAD_METADATA = 3&
    MF_MEDIA_ENGINE_PRELOAD_AUTOMATIC = 4&
End Enum

Public Enum MF_MEDIA_ENGINE_NETWORK
    MF_MEDIA_ENGINE_NETWORK_EMPTY = 0&
    MF_MEDIA_ENGINE_NETWORK_IDLE = 1&
    MF_MEDIA_ENGINE_NETWORK_LOADING = 2&
    MF_MEDIA_ENGINE_NETWORK_NO_SOURCE = 3&
End Enum

Public Enum MF_MEDIA_ENGINE_ERR
    MF_MEDIA_ENGINE_ERR_NOERROR = 0&
    MF_MEDIA_ENGINE_ERR_ABORTED = 1&
    MF_MEDIA_ENGINE_ERR_NETWORK = 2&
    MF_MEDIA_ENGINE_ERR_DECODE = 3&
    MF_MEDIA_ENGINE_ERR_SRC_NOT_SUPPORTED = 4&
    MF_MEDIA_ENGINE_ERR_ENCRYPTED = 5&
End Enum

Public Enum MF_MEDIA_ENGINE_READY
    MF_MEDIA_ENGINE_READY_HAVE_NOTHING = 0&
    MF_MEDIA_ENGINE_READY_HAVE_METADATA = 1&
    MF_MEDIA_ENGINE_READY_HAVE_CURRENT_DATA = 2&
    MF_MEDIA_ENGINE_READY_HAVE_FUTURE_DATA = 3&
    MF_MEDIA_ENGINE_READY_HAVE_ENOUGH_DATA = 4&
End Enum

Public Enum MF_MEDIA_ENGINE_STATISTIC
    MF_MEDIA_ENGINE_STATISTIC_FRAMES_RENDERED = 0&
    MF_MEDIA_ENGINE_STATISTIC_FRAMES_DROPPED = 1&
    MF_MEDIA_ENGINE_STATISTIC_BYTES_DOWNLOADED = 2&
    MF_MEDIA_ENGINE_STATISTIC_BUFFER_PROGRESS = 3&
    MF_MEDIA_ENGINE_STATISTIC_FRAMES_PER_SECOND = 4&
    MF_MEDIA_ENGINE_STATISTIC_PLAYBACK_JITTER = 5&
    MF_MEDIA_ENGINE_STATISTIC_FRAMES_CORRUPTED = 6&
    MF_MEDIA_ENGINE_STATISTIC_TOTAL_FRAME_DELAY = 7&
End Enum

Public Enum MF_MEDIA_ENGINE_EVENT
    MF_MEDIA_ENGINE_EVENT_LOADSTART = 1&
    MF_MEDIA_ENGINE_EVENT_PROGRESS = 2&
    MF_MEDIA_ENGINE_EVENT_SUSPEND = 3&
    MF_MEDIA_ENGINE_EVENT_ABORT = 4&
    MF_MEDIA_ENGINE_EVENT_ERROR = 5&
    MF_MEDIA_ENGINE_EVENT_EMPTIED = 6&
    MF_MEDIA_ENGINE_EVENT_STALLED = 7&
    MF_MEDIA_ENGINE_EVENT_PLAY = 8&
    MF_MEDIA_ENGINE_EVENT_PAUSE = 9&
    MF_MEDIA_ENGINE_EVENT_LOADEDMETADATA = 10&
    MF_MEDIA_ENGINE_EVENT_LOADEDDATA = 11&
    MF_MEDIA_ENGINE_EVENT_WAITING = 12&
    MF_MEDIA_ENGINE_EVENT_PLAYING = 13&
    MF_MEDIA_ENGINE_EVENT_CANPLAY = 14&
    MF_MEDIA_ENGINE_EVENT_CANPLAYTHROUGH = 15&
    MF_MEDIA_ENGINE_EVENT_SEEKING = 16&
    MF_MEDIA_ENGINE_EVENT_SEEKED = 17&
    MF_MEDIA_ENGINE_EVENT_TIMEUPDATE = 18&
    MF_MEDIA_ENGINE_EVENT_ENDED = 19&
    MF_MEDIA_ENGINE_EVENT_RATECHANGE = 20&
    MF_MEDIA_ENGINE_EVENT_DURATIONCHANGE = 21&
    MF_MEDIA_ENGINE_EVENT_VOLUMECHANGE = 22&
    MF_MEDIA_ENGINE_EVENT_FORMATCHANGE = 1000&
    MF_MEDIA_ENGINE_EVENT_PURGEQUEUEDEVENTS = 1001&
    MF_MEDIA_ENGINE_EVENT_TIMELINE_MARKER = 1002&
    MF_MEDIA_ENGINE_EVENT_BALANCECHANGE = 1003&
    MF_MEDIA_ENGINE_EVENT_DOWNLOADCOMPLETE = 1004&
    MF_MEDIA_ENGINE_EVENT_BUFFERINGSTARTED = 1005&
    MF_MEDIA_ENGINE_EVENT_BUFFERINGENDED = 1006&
    MF_MEDIA_ENGINE_EVENT_FRAMESTEPCOMPLETED = 1007&
    MF_MEDIA_ENGINE_EVENT_NOTIFYSTABLESTATE = 1008&
    MF_MEDIA_ENGINE_EVENT_FIRSTFRAMEREADY = 1009&
    MF_MEDIA_ENGINE_EVENT_TRACKSCHANGE = 1010&
    MF_MEDIA_ENGINE_EVENT_OPMINFO = 1011&
    MF_MEDIA_ENGINE_EVENT_RESOURCELOST = 1012&
    MF_MEDIA_ENGINE_EVENT_DELAYLOADEVENT_CHANGED = 1013&
    MF_MEDIA_ENGINE_EVENT_STREAMRENDERINGERROR = 1014&
    MF_MEDIA_ENGINE_EVENT_SUPPORTEDRATES_CHANGED = 1015&
    MF_MEDIA_ENGINE_EVENT_AUDIOENDPOINTCHANGE = 1016&
End Enum

' ----==== Public Types ====----
Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type MFARGB
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbAlpha As Byte
End Type

Public Type MFVideoNormalizedRect
    Left As Single
    Top As Single
    Right As Single
    Bottom As Single
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData0 As Long
    vData1 As Long
End Type

